base-4.7.0.2: Basic libraries

Copyright | (c) The University of Glasgow 2001
License | BSD-style (see the file libraries/base/LICENSE)
Maintainer | libraries@haskell.org
Stability | experimental
Portability | non-portable (uses Control.Monad.ST.Lazy)
Safe Haskell | Safe
Language | Haskell2010

Data.STRef.Lazy

Contents

- STRefs

Description

Mutable references in the lazy ST monad.

Synopsis

- data STRef s a
- newSTRef :: a -> ST s (STRef s a)
- readSTRef :: STRef s a -> ST s a
- writeSTRef :: STRef s a -> a -> ST s ()
- modifySTRef :: STRef s a -> (a -> a) -> ST s ()

# STRefs

data STRef s a

a value of type `STRef s a` is a mutable variable in state thread `s`, containing a value of type `a`

Instances

Typeable2 STRef |
Eq (STRef s a) |
Typeable (* -> * -> *) STRef |

newSTRef :: a -> ST s (STRef s a)

readSTRef :: STRef s a -> ST s a

writeSTRef :: STRef s a -> a -> ST s ()

modifySTRef :: STRef s a -> (a -> a) -> ST s ()